# Welcome to Swonkie Challenge

In order to accomplish the task presented bellow you will need the following tools:

 - A cool and functional Code Editor or IDE (we like VSCode, but it's your choice)
 - Docker: [Windows](https://desktop.docker.com/win/stable/Docker%20Desktop%20Installer.exe) ([WSL2](https://docs.microsoft.com/en-us/windows/wsl/install-win10) installation, you will need it), [Mac OS](https://desktop.docker.com/mac/stable/Docker.dmg) and [Linux](https://docs.docker.com/engine/install/ubuntu/)
 - Git: [Windows](https://git-scm.com/download/win), [Mac OS](https://git-scm.com/download/mac) and [Linux](https://git-scm.com/download/linux)

After having everything setup, clone this repo to your local machine and run the command:

> docker-compose up --build -d

This will create a container named "swk-challenge", after the container creation you should be able to access the service via [localhost:795](http://localhost:795), if the returns an error maybe the container isn't fully started yet, check the logs with:

> docker logs -f swk-challenge

Once it starts this [localhost:795](http://localhost:795) should display `Hello from swk dev team`.

# Challenge
This is where the fun starts 💻🥳

The challenge here is to build a web app that lists a Youtube channel's videos and allows the user to click the video and watch it.

This as to be made using:
 - React
 - SCSS

The following features are required:

 - Input to insert the channel url the user wants to list videos from
 - List the videos from the channel provided in a side panel
 - When a video is clicked play it in an iframe filling the rest of the window

The layout is your choice, make it pretty.

# Helpful Links
 - https://reactjs.org/tutorial/tutorial.html
 - https://danielmiessler.com/blog/rss-feed-youtube-channel/
 - https://developers.google.com/youtube/player_parameters
 - https://cors-anywhere.herokuapp.com/
 - https://www.npmjs.com/package/axios

# Tips

## Docker on windows
In windows you should have your projects inside the WSL environment to do this you can open the CMD and type:

> wsl

Then you will enter WSL environment, navigate to you user dir and created a dir named `projects`:

> cd ~
>
> mkdir projects
>
> cd projects

Now you can clone this repo to your dir:

> git clone git@gitlab.com:example-repo.git

## Install react packages
To install packages with this setup you need to send the command to be process inside the container, like this:

> docker exec -it swk-challenge npm install --save example-package

Some times react dev environment doesn't detect the new package automatically, in those cases a quick restart should fix it:

> docker restart swk-challenge